#![forbid(unused_imports)]
#![warn(missing_debug_implementations)]

//! Diflouroborane
//!
//! This is the server component of the FabAccess project.
//! The entry point of bffhd can be found in [bin/bffhd/main.rs](../bin/bffhd/main.rs)
//!
//! P.S.: If you're curious about the name; the project was initially called "Better Fablab
//! Friend and Helper" (BFFH). And the chemical formula of Diflouroborane is BF2H.

/// Internal Databases build on top of LMDB, a mmap()'ed B-tree DB optimized for reads
pub mod db;
/// Shared error type
pub mod error;
pub mod oid;
/// Policy decision engine
pub mod permissions;
/// Resources
pub mod resource;
/// State of Resources
pub mod state;
/// Varints
pub mod varint;

use intmap::IntMap;
use resource::ResourceDriver;

#[derive(Debug)]
struct InitiatorDriver;
#[derive(Debug)]
struct ActorDriver;

#[derive(Debug)]
struct System {
    resources: IntMap<ResourceDriver>,
    initiators: IntMap<InitiatorDriver>,
    actors: IntMap<ActorDriver>,
}

#[derive(Debug)]
struct Accountant {

}